clear all;
% Nastaveni vlasnosti zobrazovane latky - casu T1 a T2
t1 = 1; %[s]
t2 = .2; %[s]

% Nastaveni uhlu RF pulsu
pulseAngle = pi/16; %[radian]


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NEMENIT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Tpulse = 1e-5;
Trelax = .04;
% Nastaveni pulsni sekvence
b1 = [zeros(1,50) sinc(-pi:pi/25:pi) zeros(1,50) zeros(1,100)];

% Nastaveni gradientu ve smeru x
g  = [zeros(1,151) zeros(1,100)];

% Casy, ve kterych plati nasteveni pulsu a gradientu
t = [ones(1,151)*Tpulse ones(1,100)*Trelax];
tP  = Tpulse*(0:150);
tP  = [tP (max(tP)+0.00001+(1:100)*Trelax)];

% Nastaveni sily pulsu, tak aby byl vyslan puls otacejici vektor
% magnetizace M0 o prislusny uhel
b1 = pulseAngle*b1/max(b1)/2.24;

[mx,my,mz] = bloch(b1,g,t,t1,t2,0,0,2,0,0,1);

% Vykresleni vektoru magnetizace ve smeru x a z pro dany excitovany bod
figure();
subplot(121);
plot(tP(1:150)*1e3,mx(1:150,1,1),'r',tP(1:150)*1e3,mz(1:150,1,1),'b');
xlabel('Cas [ms]'); ylabel('Magnetizace'); 
title('Magnetizace behem pusobeni RF pulsu');
legend('Mxy','Mz'); grid on;
subplot(122);
plot(tP*1e3,mx(:,1,1),'r',tP*1e3,mz(:,1,1),'b');
xlabel('Cas [ms]'); ylabel('Magnetizace'); 
title('Magnetizace a relaxace po RF pulsu');
legend('Mxy','Mz'); grid on;
