clc; close all;
clear variables;

t1 = 1; %T1[s] pro prvni bod
t1b = 1.4; %T1[s] pro druhy bod
t2 = .12; %T2[s] - stejna pro oba body
TR = 4; %Repetition time [s] - maximalne 4s

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NEMENIT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Tpulse = 1e-5;
Trelax = TR/100;
b1 = [zeros(1,50) sinc(-pi:pi/25:pi) zeros(1,50) zeros(1,100)];
t = [ones(1,151)*Tpulse ones(1,100)*Trelax];
tP  = Tpulse*(0:150);
tP  = [tP (max(tP)+1e-8+(1:100)*Trelax)];
g  = [zeros(1,151) zeros(1,100)];

b1 = pi/2*b1/max(b1)/2.24;
dp = [0]';

zMag = [1];
[mx,my,mz] = bloch(b1,g,t,t1,t2,0,dp,2,[0],[0],zMag);
[mxb,myb,mzb] = bloch(b1,g,t,t1b,t2,0,dp,2,[0],[0],zMag);
figure();plot(tP*1e3,mx(:,1,1),'r',tP*1e3,mz(:,1,1),'b',tP*1e3,mxb(:,1,1),'m',tP*1e3,mzb(:,1,1),'c');
xlabel('Cas [ms]'); ylabel('Magnetizace'); title('Signal pro dve latky s ruznou T1 po excitaci 1');
legend('Mxy T1','Mz T1','Mxy T1b','Mz T1b');

tdis = tP;
mxdis = mx;
mzdis = mz;
mxbdis = mxb;
mzbdis = mzb;

for k=1:2
    mx = squeeze(mx(251,:,:));
    my = squeeze(my(251,:,:));
    mz = squeeze(mz(251,:,:));
    mxb = squeeze(mxb(251,:,:));
    myb = squeeze(myb(251,:,:));
    mzb = squeeze(mzb(251,:,:));    
    [mx,my,mz] = bloch(b1,g,t,t1*2,t2/2,0,dp,2,mx,my,mz);
    [mxb,myb,mzb] = bloch(b1,g,t,t1b*2,t2/2,0,dp,2,mxb,myb,mzb);
    tdis = [tdis (tP+max(tdis)+1e-8)];
    mxdis = [mxdis; mx];
    mzdis = [mzdis; mz];
    mxbdis = [mxbdis; mxb];
    mzbdis = [mzbdis; mzb];
    figure();plot(tP*1e3,mx(:,1,1),'r',tP*1e3,mz(:,1,1),'b',tP*1e3,mxb(:,1,1),'m',tP*1e3,mzb(:,1,1),'c');
    xlabel('Cas [ms]'); ylabel('Magnetizace'); title(['Signal pro dve latky s ruznou T1 po excitaci ' num2str(k+1)]);
legend('Mxy T1','Mz T1','Mxy T1b','Mz T1b');
end;
figure();plot(tdis*1e3,mxdis(:,1,1),'r',tdis*1e3,mzdis(:,1,1),'b',tdis*1e3,mxbdis(:,1,1),'m',tdis*1e3,mzbdis(:,1,1),'c');
xlabel('Cas [ms]'); ylabel('Magnetizace'); title('Signal pro dve latky s ruznou T1, cely prubeh');
legend('Mxy T1','Mz T1','Mxy T1b','Mz T1b');